"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _vuePropertyDecorator = require("vue-property-decorator");

require("./style/index.less");

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var __extends = void 0 && (void 0).__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

var __decorate = void 0 && (void 0).__decorate || function (decorators, target, key, desc) {
  var c = arguments.length,
      r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
      d;
  if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
    if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  }
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};

var Button =
/** @class */
function (_super) {
  __extends(Button, _super);

  function Button() {
    var _this = _super !== null && _super.apply(this, arguments) || this;

    _this.showLoading = false;
    _this.block = false;
    return _this;
  }

  Button.prototype.handleClick = function () {
    this.$emit("click");
  };

  Button.prototype.render = function () {
    var _a = this,
        showLoading = _a.showLoading,
        block = _a.block,
        $slots = _a.$slots;

    var className = {
      'sn-button': true,
      'loading': showLoading,
      'sn-button-block': block
    };
    return h("button", {
      "class": className,
      "on": {
        "click": this.handleClick
      }
    }, [h("span", [$slots["default"]])]);
  };

  __decorate([(0, _vuePropertyDecorator.Prop)()], Button.prototype, "showLoading", void 0);

  __decorate([(0, _vuePropertyDecorator.Prop)()], Button.prototype, "block", void 0);

  __decorate([(0, _vuePropertyDecorator.Emit)()], Button.prototype, "handleClick", null);

  Button = __decorate([_vuePropertyDecorator.Component], Button);
  return Button;
}(_vuePropertyDecorator.Vue);

var _default = Button;
exports["default"] = _default;
//# sourceMappingURL=index.js.map
